class Camera:
    def __init__(self):
        self.camX = 0 # will be reset shortly
        self.camY = 0 # will be reset shortly
        self.camWidth = 640  #screen is 640 wide
        self.camHeight = 480 #screen is 480 tall
        self.xEdge = 300 # how far to the x does it need to be to scroll
        self.yEdge = 220 # how far to the y does it need to be to scroll
        self.maxX = 0
        self.maxY = 0
        self.actorRef = 0 # actor pointer

    def setTarget(self, actor):
        self.actorRef = actor

    def setManual(self, newX, newY):
        self.actorRef = 0
        self.camX = newX
        self.camY = newY

    def setMaxCamera(self, maxX, maxY):
        self.maxX = maxX
        self.maxY = maxY

    def update(self):
        # check to see if our camera is not focused on the character,
        # or if the character has breached our boundaries
        #if self.actorRef.px > self.xEdge and self.actorRef.py > self.yEdge and \
        #   self.actorRef.px < self.maxX and self.actorRef.py < self.maxY:        
        if self.actorRef.px - self.camX < self.xEdge:
            self.camX -= self.xEdge-(self.actorRef.px - self.camX)
        elif self.actorRef.px > self.camX + self.camWidth - self.xEdge:
            self.camX += (self.actorRef.px - (self.camX + self.camWidth - self.xEdge))
        if self.actorRef.py - self.camY < self.yEdge:
            self.camY -= self.yEdge-(self.actorRef.py - self.camY)
        elif self.actorRef.py > self.camY + self.camHeight - self.yEdge:
            self.camY += (self.actorRef.py - (self.camY + self.camHeight - self.yEdge))
        if self.camX < 0:
            self.camX = 0
        if self.camY < 0:
            self.camY = 0
        if self.camX > self.maxX:
            self.camX = self.maxX
        if self.camY > self.maxY:
            self.camY = self.maxY

    def pos(self):
        return [self.camX,self.camY]
